local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end

local AddonName, AddonTable = ...
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary
local spells = AddonTable.Spells

local function flashPresence(name)
	if not s.Buff(name.." Presence", "player") then
		s.FlashForm(name.." Presence", "White", 300)
	end
end

local function flashBlood()
	flashPresence("Blood")	
	if not s.InCombat() then
		if not s.Buff("Bone Shield", "player") then
			c.flash("Bone Shield")
		end
		return
	end
	
	-- non-GCD cooldowns
	c.flashAll("yellow", "Rune Tap", "Empower Rune Weapon when low")
	c.rotateCooldowns(
		{"Master Tactician"},
		"Dancing Rune Weapon",
		"Bone Shield",
		"Vampiric Blood",
		"Fire of the Deep",
		"Icebound Fortitude")
	
	-- rotation
	flashing = c.priorityFlash(
		"white",
		"Death Strike for Health",
		"Death Strike to Save Shield",
		"Blood Tap for Death Strike for Health",
		"Outbreak for Debuffs",
		"Icy Touch for Debuff",
		"Plague Strike for Debuff",
		"Death Strike if Two Available",
		"Blood Tap for Death Strike for Health",
		"Rune Strike if Capped",
		"Rune Strike for Runic Empowerment",
		"Heart Strike",
		"Free Blood Boil",
		"Horn of Winter")
end

local obliterateDelay = GetTime()
function DelayObliterate()
	obliterateDelay = GetTime() + .9
end
local kmDelay = GetTime()
function DelayKM()
	kmDelay = GetTime() + .6
end
local rpBump = 0
local rpBumpTime = 0
function BumpRP(amount)
	rpBump = s.Power("player") + amount
	rpBumpTime = GetTime() + .6
end
local function flashNoCap(rp, wouldAdd, spell)
	if c.isFlashable(c.spells[spell]) then
		if s.MaxPower("player") - rp <= wouldAdd then
			s.Flash(c.spells["FS"].SpellID)
		else
			s.Flash(c.spells[spell].SpellID, "white")
		end
		return true
	else
		return false
	end
end
local function flashFrost()
	flashPresence("Unholy")
	
	if not s.InCombat() then
		return
	end
	
	if GetTime() < rpBumpTime then
		rp = rpBump
	else
		rp = s.Power("player")
	end
	
	-- non-GCD cooldowns
	c.flashAll(
		"yellow", 
		"Pillar of Frost", 
		"Blood Tap", 
		"Empower Rune Weapon when low")
	
	-- diseases
	km = GetTime() > kmDelay and s.Buff("Killing Machine", "player")
	if km and c.flash("Frost Strike if missing disease") then
		return
	end
	if c.flash("Outbreak") then
		return
	end
--	if flashNoCap(rp, 10, "Rime for FF") then
--		return
--	end
	if flashNoCap(rp, 20, "HB for FF") then
		return
	end
	if flashNoCap(rp, 10, "PS for BP") then
		return
	end
	
	-- killing machine
	if km then
		if flashNoCap(rp, 30, "OB no Rime") then
			return
		end
		if c.flash("FS") then
			return
		end
	end
	
	-- obliterate
	toFill = s.MaxPower("player") - rp
	if spells.bothRunesAvailable("Unholy", 1) then
		if toFill <= 30 then
			c.flash("FS")
			return
		elseif c.flash("OB") then
			return
		end
	end
	if spells.bothRunesAvailable("Unholy", 2) then
		if s.Buff("Freezing Fog", "player") then
			if toFill <= 10 then
				c.flash("FS")
				return
			end
		elseif toFill <= 20 then
			c.flash("FS")
			return
		end
	end
	
	-- howling blast
	if flashNoCap(rp, 10, "Rime") then
		return
	end
	if flashNoCap(rp, 20, "HB") then
		return
	end
	
	-- frost strike
	c.priorityFlash("white", "FS", "Horn of Winter")
end

s.Spam[AddonName] = function()
	if s.GetModuleConfig(AddonName, "spell_flashing_off") then 
		return
	end
	
	c.gcdSpell = "Death Coil"
	c.spells = spells
	c.addonName = AddonName
	c.run(flashBlood, 1, "blood_off")
	c.run(flashFrost, 2, "frost_off")
end
